| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Data Structures | Functions
CDC Class Device Mode Driver
CDC-ACM (Virtual Serial) Class Driver

## Data Structures
struct | USB_ClassInfo_CDC_Device_t
| CDC Class Device Mode Configuration and State Structure. More...

## Functions
uint16_t | CDC_Device_BytesReceived (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
bool | CDC_Device_ConfigureEndpoints (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
void | CDC_Device_CreateBlockingStream (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo, FILE *const Stream) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
void | CDC_Device_CreateStream (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo, FILE *const Stream) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
uint8_t | CDC_Device_Flush (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
void | CDC_Device_ProcessControlRequest (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
int16_t | CDC_Device_ReceiveByte (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | CDC_Device_SendByte (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo, const uint8_t Data) ATTR_NON_NULL_PTR_ARG(1)
void | CDC_Device_SendControlLineStateChange (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | CDC_Device_SendData (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo, const void *const Buffer, const uint16_t Length) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
uint8_t | CDC_Device_SendString (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo, const char *const String) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
void | CDC_Device_USBTask (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
void | EVENT_CDC_Device_BreakSent (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo, const uint8_t Duration) ATTR_NON_NULL_PTR_ARG(1)
void | EVENT_CDC_Device_ControLineStateChanged (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
void | EVENT_CDC_Device_LineEncodingChanged (USB_ClassInfo_CDC_Device_t *const CDCInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)

## Detailed Description

# Module Source Dependencies

The following files must be built with any user project that uses this module:

- LUFA/Drivers/USB/Class/Device/CDCClassDevice.c (Makefile source module name: LUFA_SRC_USBCLASS)

# Module Description

Device Mode USB Class driver framework interface, for the CDC USB Class driver.

Note
  There are several major drawbacks to the CDC-ACM standard USB class, however it is very standardized and thus usually available as a built-in driver on most platforms, and so is a better choice than a proprietary serial class.

One major issue with CDC-ACM is that it requires two Interface descriptors, which will upset most hosts when part of a multi-function "Composite" USB device. This is because each interface will be loaded into a separate driver instance, causing the two interfaces be become unlinked. To prevent this, you should use the "Interface Association Descriptor" addendum to the USB 2.0 standard which is available on most OSes when creating Composite devices.

Another major oversight is that there is no mechanism for the host to notify the device that there is a data sink on the host side ready to accept data. This means that the device may try to send data while the host isn't listening, causing lengthy blocking timeouts in the transmission routines. It is thus highly recommended that the virtual serial line DTR (Data Terminal Ready) signal be used where possible to determine if a host application is ready for data.

## Function Documentation

uint16_t CDC_Device_BytesReceived | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo | ) |

Determines the number of bytes received by the CDC interface from the host, waiting to be read. This indicates the number of bytes in the OUT endpoint bank only, and thus the number of calls to CDC_Device_ReceiveByte() which are guaranteed to succeed immediately. If multiple bytes are to be received, they should be buffered by the user application, as the endpoint bank will not be released back to the USB controller until all bytes are read.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.

Returns
  Total number of buffered bytes received from the host.

bool CDC_Device_ConfigureEndpoints | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo | ) |

Configures the endpoints of a given CDC interface, ready for use. This should be linked to the library EVENT_USB_Device_ConfigurationChanged() event so that the endpoints are configured when the configuration containing the given CDC interface is selected.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.

Returns
  Boolean `true` if the endpoints were successfully configured, `false` otherwise.

void CDC_Device_CreateBlockingStream | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo,
|  | FILE *const | Stream
| ) |  |

Identical to CDC_Device_CreateStream(), except that reads are blocking until the calling stream function terminates the transfer. While blocking, the USB and CDC service tasks are called repeatedly to maintain USB communications.

Note
  This function is not available on all microcontroller architectures.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.
  [in,out] | Stream | Pointer to a FILE structure where the created stream should be placed.

void CDC_Device_CreateStream | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo,
|  | FILE *const | Stream
| ) |  |

Creates a standard character stream for the given CDC Device instance so that it can be used with all the regular functions in the standard <stdio.h> library that accept a `FILE` stream as a destination (e.g. `fprintf()`). The created stream is bidirectional and can be used for both input and output functions.

Reading data from this stream is non-blocking, i.e. in most instances, complete strings cannot be read in by a single fetch, as the endpoint will not be ready at some point in the transmission, aborting the transfer. However, this may be used when the read data is processed byte-per-bye (via `getc()`) or when the user application will implement its own line buffering.

Note
  The created stream can be given as `stdout` if desired to direct the standard output from all `<stdio.h>` functions to the given CDC interface.
  This function is not available on all microcontroller architectures.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.
  [in,out] | Stream | Pointer to a FILE structure where the created stream should be placed.

uint8_t CDC_Device_Flush | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo | ) |

Flushes any data waiting to be sent, ensuring that the send buffer is cleared.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.

Returns
  A value from the Endpoint_WaitUntilReady_ErrorCodes_t enum.

void CDC_Device_ProcessControlRequest | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo | ) |

Processes incoming control requests from the host, that are directed to the given CDC class interface. This should be linked to the library EVENT_USB_Device_ControlRequest() event.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.

int16_t CDC_Device_ReceiveByte | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo | ) |

Reads a byte of data from the host. If no data is waiting to be read of if a USB host is not connected, the function returns a negative value. The CDC_Device_BytesReceived() function may be queried in advance to determine how many bytes are currently buffered in the CDC interface's data receive endpoint bank, and thus how many repeated calls to this function which are guaranteed to succeed.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.

Returns
  Next received byte from the host, or a negative value if no data received.

uint8_t CDC_Device_SendByte | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo,
|  | const uint8_t | Data
| ) |  |

Sends a given byte to the attached USB host, if connected. If a host is not connected when the function is called, the byte is discarded. Bytes will be queued for transmission to the host until either the endpoint bank becomes full, or the CDC_Device_Flush() function is called to flush the pending data to the host. This allows for multiple bytes to be packed into a single endpoint packet, increasing data throughput.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.
  [in] | Data | Byte of data to send to the host.

Returns
  A value from the Endpoint_WaitUntilReady_ErrorCodes_t enum.

void CDC_Device_SendControlLineStateChange | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo | ) |

Sends a Serial Control Line State Change notification to the host. This should be called when the virtual serial control lines (DCD, DSR, etc.) have changed states, or to give BREAK notifications to the host. Line states persist until they are cleared via a second notification. This should be called each time the CDC class driver's `ControlLineStates.DeviceToHost` value is updated to push the new states to the USB host.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.

uint8_t CDC_Device_SendData | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo,
|  | const void *const | Buffer,
|  | const uint16_t | Length
| ) |  |

Sends a given data buffer to the attached USB host, if connected. If a host is not connected when the function is called, the string is discarded. Bytes will be queued for transmission to the host until either the endpoint bank becomes full, or the CDC_Device_Flush() function is called to flush the pending data to the host. This allows for multiple bytes to be packed into a single endpoint packet, increasing data throughput.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.
  [in] | Buffer | Pointer to a buffer containing the data to send to the device.
  [in] | Length | Length of the data to send to the host.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum.

uint8_t CDC_Device_SendString | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo,
|  | const char *const | String
| ) |  |

Sends a given null terminated string to the attached USB host, if connected. If a host is not connected when the function is called, the string is discarded. Bytes will be queued for transmission to the host until either the endpoint bank becomes full, or the CDC_Device_Flush() function is called to flush the pending data to the host. This allows for multiple bytes to be packed into a single endpoint packet, increasing data throughput.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.
  [in] | String | Pointer to the null terminated string to send to the host.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum.

void CDC_Device_USBTask | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo | ) |

General management task for a given CDC class interface, required for the correct operation of the interface. This should be called frequently in the main program loop, before the master USB management task USB_USBTask().

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.

void EVENT_CDC_Device_BreakSent | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo,
|  | const uint8_t | Duration
| ) |  |

CDC class driver event for a send break request sent to the device from the host. This is generally used to separate data or to indicate a special condition to the receiving device.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.
  [in] | Duration | Duration of the break that has been sent by the host, in milliseconds.

void EVENT_CDC_Device_ControLineStateChanged | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo | ) |

CDC class driver event for a control line state change on a CDC interface. This event fires each time the host requests a control line state change (containing the virtual serial control line states, such as DTR) and may be hooked in the user program by declaring a handler function with the same name and parameters listed here. The new control line states are available in the `ControlLineStates.HostToDevice` value inside the CDC interface structure passed as a parameter, set as a mask of `CDC_CONTROL_LINE_OUT_*` masks.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.

void EVENT_CDC_Device_LineEncodingChanged | ( | USB_ClassInfo_CDC_Device_t *const | CDCInterfaceInfo | ) |

CDC class driver event for a line encoding change on a CDC interface. This event fires each time the host requests a line encoding change (containing the serial parity, baud and other configuration information) and may be hooked in the user program by declaring a handler function with the same name and parameters listed here. The new line encoding settings are available in the `LineEncoding` structure inside the CDC interface structure passed as a parameter.

Parameters

  [in,out] | CDCInterfaceInfo | Pointer to a structure containing a CDC Class configuration and state.